module full_adder(
    input a,b,
    input cin,
    output s,
    output cout
    );

assign s = a ^ b ^ cin;
assign cout = (a & b) | (a & cin) | (b & cin);

endmodule


module main;

reg a,b;
reg cin;
wire s, cout;
full_adder FA(a, b, cin, s, cout);

initial begin
$display ("time\t a b c_in s   c_out");	
$monitor ("%g\t     %b %b %b    %b     %b", $time, a, b, cin, s, cout);

a=0;
b=0;
cin=0;
#10

a=0;
b=0;
cin=1;
#10

a=0;
b=1;
cin=0;
#10

a=0;
b=1;
cin=1;
#10

a=1;
b=0;
cin=0;
#10

a=1;
b=0;
cin=1;
#10

a=1;
b=1;
cin=0;
#10

a=1;
b=1;
cin=1;
#10

$finish;

end
endmodule