module mux4_1( 
    input a, b, c, d,
    input [1:0] sel,
    output out 
    );

wire [1:0] sel_b;

not not0( sel_b[0], sel[0] );
not not1( sel_b[1], sel[1] );

wire n0, n1, n2, n3;

and and0(n0, c, sel[1]	);
and and1(n1, a, sel_b[1] );
and and2(n2, d, sel[1]	);
and and3(n3, b, sel_b[1] );

wire x0, x1; 

nor nor0( x0, n0, n1);
nor nor1( x1, n2, n3);

wire y0, y1;
or or0( y0, x0, sel[0]	);
or or1( y1, x1, sel_b[0] );

nand nand0( out, y0, y1 );

endmodule

module mux4_2(
    input a, b, c, d,
    input [1:0] sel,
	output out
    );
 
    assign out = 
        (a & ~sel[1] & ~sel[0])  |
        (b & ~sel[1] & sel[0])   |
        (c & sel[1] & ~sel[0])   |
        (d & sel[1] & sel[0]);
 
endmodule


module mux4_3(
    input a, b, c, d,
    input [1:0] sel,
    output reg out
    );
 
    always @(*)
    begin
        case (sel)
            2'b00: out = a;
            2'b01: out = b;
            2'b10: out = c;
            2'b11: out = d;
            default: out = 1'bx;
        endcase
    end
 
endmodule

module main;

reg a,b,c,d;
reg [1:0] sel;
wire out;
mux4_1 multiplexor(a, b, c, d, sel, out);

initial begin
$display ("time\t abcd sel   out");	
$monitor ("%g\t     %b%b%b%b %d     %b", $time, a, b, c, d, sel, out);

a=1;
b=0;
c=0;
d=0;
sel=0;
#10

a=1;
b=0;
c=0;
d=0;
sel=1;
#10

a=1;
b=0;
c=0;
d=0;
sel=2;
#10

a=1;
b=0;
c=0;
d=0;
sel=3;
#10

$finish;

end
endmodule